---
title: Installing Docker on a Pi
date: 2018-09-02 22:43:01
thumbnail: /images/docker.png
comments: false
tags:
 - Setup
categories:
 - Install
 - Docker
---
## Intro
Installing Docker on a Pi is super easy also.

First make sure your Raspian is up to date
```
sudo apt-get update
sudo apt-get upgrade
```

Then, all you need to do is run this.

```
curl -sSL https://get.docker.com | sudo sh
```

And voila, docker is installed:

```bash
pi@raspian:~$ docker info
Containers: 0
 Running: 0
 Paused: 0
 Stopped: 0
Images: 0
Server Version: 18.06.1-ce
Storage Driver: overlay2
 Backing Filesystem: extfs
 Supports d_type: true
 Native Overlay Diff: true
```

Now, you can run [my Mystic BBS](/2018/09/01/mysticbbs/) image or [my MBSE BBS](/2018/09/04/mbse) image. If you need some more info about Docker, you might find [this](/2018/10/30/dockerinfo) useful.
