---
title: MysticBBS
thumbnail: /images/mysticlogo.png
comments: false
categories:
- Docker
- MysticBBS
tags:
- Docker
- BBS
date: 2018-09-01 12:00:00
---
[Mystic BBS](http://mysticbbs.com) is great software to get up and running and get (back) into the BBS scene.

There is a wealth of information on the [wiki](http://wiki.mysticbbs.com), or you can even go through [*Mystic Guy's* YouTube videos](https://www.youtube.com/channel/UCPOUHszVXaGNSlK3AdI7kLQ).

If you would like to get up and running quickly, I've created some Docker Images which you can use as a starting point. The images are available for Raspberry Pi (ARM) and Intel.

There are two images:
<table><tr><th width="20%">Name</th><th width="80%">Information</th></tr><tr><td>armv7l</td><td>This image is a clean installation of Mystic BBS as provided by the upstream developer. It does have the pre-requisites so that spell is enabled and cryptlib is also installed so that you can use SSH based connections.</td></tr><tr><td>armv7l-extras</td><td>This image extends the base image and provides some doors and utilities.</td></tr><tr><td>x86_64</td><td>Just like the image above, however, this is for Intel Linux platforms.</td></tr><tr><td>x86_64-extras</td><td>This image extends the base image and provides some doors and utilities.</td></tr></table>

To get the images, just install docker onto your Linux platform, and then do

`docker pull registry.leenooks.net/leenooks/mysticbbs:1.12a39-[TAG ABOVE]`

To make sure your data is kept between re-creations of your docker container, you have two options:
1.  Start your mystic container with `-v [HOST PATH]:/mystic/data`, or
2.  Start your subsequent containers with `--volumes_from=[ORIG CONTAINER]`.
  In this case, you might want to rename your old container if you want to use the same container name.

You need to map some IP ports into the container when it starts, so use `-p HOST_PORT:CONTAINER_PORT`, where **HOST_PORT** is the IP port on the host that you want the services to listen on (it can be the same as the container's ports).

The services you'll probably use are:
<table><tr><th width="20%">Service</th><th width="20%">Port</th><th>Description</th><th>Suggested Mapping</th></tr><tr><td>ssh</td><td>22</td><td>SSH port for incoming SSH connections</td><td>22 (or any port number)</td></tr><tr><td>telnet</td><td>23</td><td>Telnet port for incoming telnet connections</td><td>23 (or any port number)</td></tr><tr><td>binkp</td><td>24554</td><td>BINKP port for incoming BBS Mail/File Transfers</td><td>24554 (or any port number)</td></tr></table>

For example, if you wanted to map telnet to port 10023, ssh to port 10022, and leave binkp as it, and use */srv/docker/mystic* on the host as your persistant storage inside the container, you would use:

```
docker run -it -v /srv/docker/mystic:/mystic data -p 10022:22 -p 10023:23 -p 24554:24554 registry.leenooks.net/leenooks/mysticbbs:1.12a39-armv7l
```
when it starts, it will output the container ID.

Once your container is running, you can run the mystic utils by running: `docker exec -it <CONTAINER_ID> [COMMAND]` where **COMMAND** is the command you wanted to run, eg `./mystic -cfg`, or `./fidopoll ...`.

You can also attach to the console to see what mystic is showing `docker attach <CONTAINER_ID>`, and to detach, you'll need to press **CTRL-PQ** (which is ctrl p, ctrl q). (**NOTE**: You might need to press a key, to refresh the screen - using your arrows is safe.)

You could even use this image to have your containers in a docker swarm (as I do).

If you need any help, [login](/2018/08/31/chinwag/) to my BBS and send me a message, or if you use another BBS, or a Sysop of a BBS and connected to one of the networks I'm connected to, you can send me a Netmail. See the list of [networks](/networks) that I'm already connected to.
